<?php
class Noticias_Newswire_Common
{
    const OS_UNKNOWN = 1;
    const OS_WIN = 2;
    const OS_LINUX = 3;

    public static function make_directory($path)
    {
        if (is_dir($path)) {
            return FALSE;
        }
        try {
            $oldmask = umask(0);
            mkdir($path);
            umask($oldmask);
        } catch (Exception $ex) {
            return FALSE;
        }
    }

    private static function get_log_directory()
    {
        return realpath(dirname(__FILE__)) . DIRECTORY_SEPARATOR . "logs";
    }

    public static function get_cache_directory()
    {
        return realpath(dirname(__FILE__)) . DIRECTORY_SEPARATOR . "cache";
    }

    public static function get_hours_elapsed_decimal($last_modified_timestamp)
    {
        $seconds_in_one_hour = 3600;
        $difference = time() - $last_modified_timestamp;
        $hoursDecimal = round($difference / $seconds_in_one_hour, 2);
        return $hoursDecimal;
    }

    public static function remove_file($file_path)
    {
        if (!is_file($file_path)) {
            return;
        }
        unlink($file_path);
    }

    public static function get_os()
    {
        switch (true) {
            case stristr(PHP_OS, 'WIN'):
                return self::OS_WIN;
            case stristr(PHP_OS, 'LINUX'):
                return self::OS_LINUX;
            default:
                return self::OS_UNKNOWN;
        }
    }

    public static function write_log($text)
    {
        try {
            $log_directory = self::get_log_directory();
            self::make_directory($log_directory);
            $date = str_replace("/", "-", gmdate("Y/m"));
            $file_name = $log_directory . "/log_" . $date . ".log";
            $ddf = fopen($file_name, 'a');
            $date_time = gmdate("Y/m/d H:i:s");
            fwrite($ddf, "[" . $date_time . "] " . $text . "\n");
            fclose($ddf);
        } catch (\Exception $e) {
        }
    }
}
