<?php
require_once('noticias-newswire-common.php');

class Noticias_Newswire_Feed_Repository
{
    public function get_feeds($url)
    {
        $json = FALSE;
        try {
            $content = $this->get_data_from_url($url);
            if ($content !== FALSE) {
                $json = $content;
            }
        } catch (Exception $ex) {
            return FALSE;
        }
        return $json;
    }

    public function get_data_from_url($url)
    {
        $response = '[]';
        $OK = 200;
        $FORBIDDEN = 403;
        $attempts = 0;
        $maxAttempts = 3;
        while ($attempts < $maxAttempts) {
            try {
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                $response = curl_exec($ch);
                $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                curl_close($ch);
                if ($httpCode == $OK) $attempts = $maxAttempts;
                if ($httpCode == $FORBIDDEN) {
                    $url = str_replace(NNW_DOMAIN, FAILOVER_DOMAIN, $url);
                    $url = str_replace('feed-api.php', 'feed-api', $url);
                    $placementDomain = parse_url(get_site_url(), PHP_URL_HOST );
                    $placementIP = $_SERVER['SERVER_ADDR'];
                    Noticias_Newswire_Common::write_log('Placement: ' . $placementDomain . ' - IP: ' . $placementIP . ' - 403, Failover URL: ' . $url);
                    throw new Exception();
                }
                $attempts++;
            } catch (\Exception $ex) {
                $response = '[]';
                $attempts++;
            }
        }
        return $response;
    }
}